/*
This library is a modified version of Herobrine643928's Chest UI library. (https://github.com/Herobrine643928/Chest-UI)
It has been modified for my use case. -HungryBoy02
*/ function _check_private_redeclaration(obj, privateCollection) {
    if (privateCollection.has(obj)) {
        throw new TypeError("Cannot initialize the same private elements twice on an object");
    }
}
function _class_apply_descriptor_get(receiver, descriptor) {
    if (descriptor.get) {
        return descriptor.get.call(receiver);
    }
    return descriptor.value;
}
function _class_apply_descriptor_set(receiver, descriptor, value) {
    if (descriptor.set) {
        descriptor.set.call(receiver, value);
    } else {
        if (!descriptor.writable) {
            throw new TypeError("attempted to set read only private field");
        }
        descriptor.value = value;
    }
}
function _class_extract_field_descriptor(receiver, privateMap, action) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to " + action + " private field on non-instance");
    }
    return privateMap.get(receiver);
}
function _class_private_field_get(receiver, privateMap) {
    var descriptor = _class_extract_field_descriptor(receiver, privateMap, "get");
    return _class_apply_descriptor_get(receiver, descriptor);
}
function _class_private_field_init(obj, privateMap, value) {
    _check_private_redeclaration(obj, privateMap);
    privateMap.set(obj, value);
}
function _class_private_field_set(receiver, privateMap, value) {
    var descriptor = _class_extract_field_descriptor(receiver, privateMap, "set");
    _class_apply_descriptor_set(receiver, descriptor, value);
    return value;
}
import { ActionFormData } from '@minecraft/server-ui';
const types = new Map([
    [
        'chooseoriginsmain',
        [
            `§c§h§o§o§s§e§o§r§i§g§i§n§s§m§a§i§n`,
            54
        ]
    ],
    [
        'originconfigmain',
        [
            `§o§r§i§g§i§n§c§o§n§f§i§g§m§a§i§n`,
            54
        ]
    ],
    [
        'originconfigabilities',
        [
            `§o§r§i§g§i§n§c§o§n§f§i§g§a§b§i§l§i§t§i§e§s`,
            54
        ]
    ],
    [
        'originabilityhelp',
        [
            `§o§r§i§g§i§n§a§b§i§l§i§t§y§h§e§l§p`,
            54
        ]
    ],
    [
        'book',
        [
            `§b§o§o§k`,
            54
        ]
    ]
]);
const uiTypes = {
    'chooseoriginsmain': 'chooseoriginsmain',
    'originconfigmain': 'originconfigmain',
    'originconfigabilities': 'originconfigabilities',
    'originabilityhelp': 'originabilityhelp',
    'book': 'book'
};
var _titleText = /*#__PURE__*/ new WeakMap(), _buttonArray = /*#__PURE__*/ new WeakMap(), _body = /*#__PURE__*/ new WeakMap();
class CustomFormFormData {
    /**
   * @remarks This builder method sets the title for the ui.
   * @param text The title text for the ui.
   */ title(text) {
        _class_private_field_set(this, _titleText, _class_private_field_get(this, _titleText) + text);
        return this;
    }
    /**
   * @remarks Sets the text for the body of the ui you're making
   * @param text Body text for your ui
   */ body(text) {
        _class_private_field_set(this, _body, text);
        return this;
    }
    /**
   * @remarks Adds a button to this ui with an icon from a resource pack.
   * @param slot The slot to display the item in.
   * @param itemName The name of the item to display.
   * @param itemDesc The item's lore to display.
   * @param iconPath The icon for the item.
   * @param stackAmount The stack size for the item.
   */ button(slot, itemName, itemDesc, iconPath, stackSize = 1) {
        _class_private_field_get(this, _buttonArray).splice(slot, 1, [
            `stack#${Math.min(Math.max(stackSize, 1) || 1, 99).toString().padStart(2, '0')}§r${itemName ?? ''}§r${itemDesc?.length ? `\n§r${itemDesc.join('\n§r')}` : ''}`,
            iconPath
        ]);
        return this;
    }
    /**
    * @remarks
    * Creates and shows this modal popup form. Returns
    * asynchronously when the player confirms or cancels the
    * dialog.
    *
    * This function can't be called in read-only mode.
    *
    * @param player
    * Player to show this dialog to.
   */ show(player) {
        const form = new ActionFormData();
        form.title(_class_private_field_get(this, _titleText));
        form.body(_class_private_field_get(this, _body));
        _class_private_field_get(this, _buttonArray).forEach((button)=>{
            form.button(button[0], button[1]);
        });
        return form.show(player);
    }
    /**
   * @param uitype The size of the ui. Can be 'chooseorigins', 'book' or 'originconfigmain'.
   */ constructor(uitype){
        _class_private_field_init(this, _titleText, {
            writable: true,
            value: void 0
        });
        _class_private_field_init(this, _buttonArray, {
            writable: true,
            value: void 0
        });
        _class_private_field_init(this, _body, {
            writable: true,
            value: void 0
        });
        const sizing = types.get(uitype) ?? [
            `§c§h§o§o§s§e§o§r§i§g§i§n§s`,
            54
        ];
        /** @internal */ _class_private_field_set(this, _titleText, '§g§u§i' + sizing[0] + "§r");
        _class_private_field_set(this, _body, "");
        /** @internal */ _class_private_field_set(this, _buttonArray, []);
        for(let i = 0; i < sizing[1]; i++)_class_private_field_get(this, _buttonArray).push([
            '',
            undefined
        ]);
    }
}
export { CustomFormFormData, uiTypes };
